require "engine.class"
local Dialog = require "engine.ui.Dialog"
local Checkbox = require "engine.ui.Checkbox"

module(..., package.seeall, class.inherit(Dialog))

function makeCheckbox(table, title, fieldname, index)
  table[index] = Checkbox.new{title=title, default=game.player.squelch[fieldname], fct=function() end, on_change=function(s) game.player.squelch[fieldname] = s end}
end

function _M:init()
	Dialog.init(self, "Squelch Options", 400, 800)

  if game.player.squelch == nil then
    game.player.squelch = {}
  end
  
  self.cb_list = {}
  index = 1
  self.make_cb = function(title, fieldname)
    makeCheckbox(self.cb_list, title, fieldname, index)
    index = index + 1  
  end
  self.make_cb("Preserve Uniques (takes precedence)", "preserve_uniques")
  self.make_cb("Preserve Infusions (takes precedence)", "preserve_infusions")
  self.make_cb("Preserve Runes (takes precedence)", "preserve_runes")
  self.make_cb("Squelch 1H Weapons", "onehanders")
  self.make_cb("Squelch 2H Weapons", "twohanders")
  self.make_cb("Squelch Daggers", "daggers")
  self.make_cb("Squelch Staves", "staves")
  self.make_cb("Squelch Mindstars", "mindstars")
  self.make_cb("Squelch Whips", "whips")
  self.make_cb("Squelch Tridents", "tridents")
  self.make_cb("Squelch Bows and Arrows", "bows")
  self.make_cb("Squelch Slings and Shot", "slings")
  self.make_cb("Squelch Steamsaws", "saws")
  self.make_cb("Squelch Steamguns", "guns")
  self.make_cb("Squelch Tinkers", "tinker")
  self.make_cb("Squelch Robes", "robes")
  self.make_cb("Squelch Light Armor", "light")
  self.make_cb("Squelch Heavy Armor", "heavy")
  self.make_cb("Squelch Massive Armor", "massive")
  self.make_cb("Squelch Shields", "shields")
  self.make_cb("Squelch Hats", "hats")
  self.make_cb("Squelch Helms", "helms")
  self.make_cb("Squelch Cloaks", "cloaks")
  self.make_cb("Squelch Gloves", "gloves")
  self.make_cb("Squelch Gauntlets", "gauntlets")
  self.make_cb("Squelch Belts", "belts")
  self.make_cb("Squelch Boots", "boots")
  self.make_cb("Squelch Sabatons", "sabatons")
  self.make_cb("Squelch Lights", "lites")
  self.make_cb("Squelch Wands", "wands")
  self.make_cb("Squelch Torques", "torques")
  self.make_cb("Squelch Totems", "totems")
  self.make_cb("Squelch Diggers", "diggers")
  self.make_cb("Squelch Amulets", "amulets")
  self.make_cb("Squelch Rings", "rings")
  self.make_cb("Squelch Infusions", "infusions")
  self.make_cb("Squelch Runes", "runes")
  self.make_cb("Squelch All Arcane", "arcane")
  self.make_cb("Squelch All Arcane-Disrupting", "disrupting")
  self.make_cb("Squelch White Inscriptions", "whiteinscriptions")
  self.make_cb("Squelch White Jewelry", "whitejewelry")
  self.make_cb("Squelch All Other Whites", "whiteequip")
  self.make_cb("Squelch All Tier 1", "tier1")
  self.make_cb("Squelch All Tier 2", "tier2")
  self.make_cb("Squelch All Tier 3", "tier3")
  self.make_cb("Squelch All Tier 4", "tier4")
  self.make_cb("Squelch All (Greater Egos == 0) Items", "gego0")
  self.make_cb("Squelch All (Greater Egos == 1) Items", "gego1")

  uitable = {}
  topPos = 0
  leftPos = 0
  maxLeft = 0
  for k,v in ipairs(self.cb_list) do
    if #uitable == math.ceil(#self.cb_list / 2) then
      leftPos = maxLeft
      topPos = 0
    end
    uitable[#uitable+1] = {left=leftPos, top=topPos, ui=v}
    if uitable[#uitable].left + v.w + 10 > maxLeft then
      maxLeft = uitable[#uitable].left + v.w + 10
    end
    topPos = topPos + v.h + 10
  end

	self:loadUI(uitable)
	self:setupUI(true, true)

	self.key:addBinds{
		EXIT = function() game:unregisterDialog(self) end,
	}
end
